'========================
' This script will save the current PP
'
' Avaliable parameters:
'
' ARG1 - allows To give the Name To save To. If Not given Or "", Then the current PP Name is used
'
' ARG2 - allows To define Any suffix value, that will be appended To the PP Name. Suggestion : use some variable, that my comne from the Loop counter
' Or some String constructed by the current date, Or some user Input. May be also ommited
'
'  Example 1 (will save the PP, using the current PP Name, adding a suffix "3" To the Name...) :
'
' CS1        =SCRIPT/FILENAME= C:\USERS\AMAVROV\DESKTOP\SAVEPRG.BAS
'             Function/Main,SHOW=YES,ARG1="",ARG2="3",,
'             STARTSCRIPT/
'             ENDSCRIPT/
'
'  Example 2 (will save the PP within the Loop, using the current PP Name, adding a suffix of the date/time stamp) :
'
'V1         =Loop/START,ID=YES,NUMBER=4,START=1,SKIP=,
'              OFFSET:XAXIS=0,YAXIS=0,ZAXIS=0,ANGLE=0
'...
'...
'...
'            ASSIGN/MYDATE=SYSTEMDATE("dd-MM-yyyy")
'            ASSIGN/MYTIME=SYSTEMTIME("hh-mm-ss")
'            ASSIGN/MYDATE_TIME=MYDATE + "_" + MYTIME
'CS1        =SCRIPT/FILENAME= C:'\USERS\AMAVROV\DESKTOP\SAVEPRG.BAS
'            Function/Main,SHOW=YES,ARG1="",ARG2=MYDATE_TIME,,
'            STARTSCRIPT/
'            ENDSCRIPT/
'            Loop/End
'========================

Option Explicit

Dim App As Object
Dim PP As Object

Sub Main (FN As String,Suffix As String)
  Dim retval As Boolean
  Dim FNOri As String

  Set App = CreateObject("PCDLRN.Application")
  Set Part = App.ActivePartProgram

  If FN="" Then
      FN= Part.Path & Part.Name
  Else
      FN=FN
  End If

  FNOri=FN

  If Suffix="" Then 
      FN=FN
  Else
      If ucase(right(FN,4))=".PRG" Then 
         FN=left(FN,len(FN)-4) & "_" & Suffix & ".prg"
      Else
         FN=FN & "_" & Suffix & ".prg"
      End If
  End If

  retval= Part.SaveAs (FN)
  If FN<>FNOri Then
     retval= Part.SaveAs (FNOri)
  End If

End Sub
